module WarningFilter
  class Filter
    def initialize(io)
      @io = io
    end

    def write(line)
      unless warning_from_gem?(line)
        @io.write(line)
      end
    end

    protected

    def warning_from_gem?(line)
      warning?(line) && from_gem?(line)
    end

    def warning?(line)
      line.include?("warning")
    end

    def from_gem?(line)
      Gem.path.any? { |path| line.include?(path) }
    end
  end
end
